<?php

/*	SimplePortal Plugin File -> Show Unread Posts v1.4x */
/*	Some SSI functions were tranfered here for possible editing 
	Limit is recent posts that new one's are selected from */

if (!defined('SMF'))
	die('Hacking attempt...');

/*
	void sportal_unread()	
	
	void unreadTopics()
	
	void unreadPosts()
	
	void unread_queryPosts()	
*/

function sportal_unread($parameters, $id, $return_parameters = false)
{
	global $txt, $scripturl, $settings, $context, $color_profile, $boardurl;

	$block_parameters = array(
		'boards' => 'boards',
		'limit' => 'int',
		'type' => 'select',
		'display' => 'select',
	);

	if ($return_parameters)
		return $block_parameters;

	$boards = !empty($parameters['boards']) ? explode('|', $parameters['boards']) : null;
	$limit = !empty($parameters['limit']) ? (int) $parameters['limit'] : 5;
	$rows = !empty($parameters['rows']) ? (int) $parameters['rows'] : 5;
	$type = 'unread' . (!empty($parameters['type']) ? $parameters['type'] : 'Posts');
	$display = !empty($parameters['display']) ? $parameters['display'] : 'full';	
	$prev = !empty($parameters['prev']) ? $parameters['prev'] : 'Prev';
	$next = !empty($parameters['next']) ? $parameters['next'] : 'Next';
	$vertical_bar_x = !empty($parameters['vbar_x']) ? $parameters['vbar_x'] : '|';
	$vertical_bar_y = !empty($parameters['vbar_y']) ? $parameters['vbar_y'] : '|';
	$images = !empty($parameters['unread_icons']) ? $parameters['unread_icons'] : false;
	$items = $type($limit, null, $boards, 'array');
	$row_height_full = !empty($parameters['full_height']) ? (int) $parameters['full_height'] : 35;
	$row_height_compact = !empty($parameters['compact_height']) ? (int) $parameters['compact_height'] : 45;
	$show_icon = !empty($parameters['show_icon']) ? $parameters['show_icon'] : 'yes';
	$current_page = !empty($_SESSION['sp_current_page']) ? (int) $_SESSION['sp_current_page'] : 1;
	$class = !empty($parameters['container_class']) ? $parameters['container_class'] : 'mediumtext';
	$style = !empty($parameters['container_style']) ? $parameters['container_style'] : 'font-family:Helvetica;';
	if ($display == 'full')
		$height = ($rows+1.88) * $row_height_full;	
	else
		$height = ($rows+0.88) * $row_height_compact;	
	$counter = 0;	
	
	/* Change text to images if enabled ... hover effect for arrows */
	if ($images)
	{		
		$prevX = $settings['default_theme_url'] .'/images/sp/back_enabled_hover.png';
		$prevY = $settings['default_theme_url'] .'/images/sp/back_disabled.png';
		$nextX = $settings['default_theme_url'] .'/images/sp/forward_enabled_hover.png';
		$nextY = $settings['default_theme_url'] .'/images/sp/forward_disabled.png';
		$vertical_bar_x = '<img src="'.$settings['default_theme_url'] .'/images/sp/vertical_bar-x.gif" alt="" />';
		$vertical_bar_y = '<img src="'.$settings['default_theme_url'] .'/images/sp/vertical_bar-y.gif" alt="" />';
		$prev = '<a onMouseOver="document.spPrev.src=\''.$prevX. '\'" onMouseOut="document.spPrev.src=\''.$prevY. '\'"><img style="vertical-align:bottom;" name="spPrev" src="'.$settings['default_theme_url'] .'/images/sp/back_disabled.png" alt="" title="" /></a>';
		$next = '<a onMouseOver="document.spNext.src=\''.$nextX. '\'" onMouseOut="document.spNext.src=\''.$nextY. '\'"><img style="vertical-align:bottom;" name="spNext" src="'.$settings['default_theme_url'] .'/images/sp/forward_disabled.png" data-hover="'.$settings['default_theme_url'] .'/images/sp/forward_disabled.png" alt="" title="" /></a>';		
	}
	
	if (empty($items))
	{
		echo '
								', $txt['error_sp_no_posts_found'];
		return;
	}
	else
		$items[count($items) - 1]['is_last'] = true;

	$colorids = array();
	foreach ($items as $item)
		$colorids[] = $item['poster']['id'];

	if (!empty($colorids) && sp_loadColors($colorids) !== false)
	{
		foreach ($items as $k => $p)
		{
			if (!empty($color_profile[$p['poster']['id']]['link']))
				$items[$k]['poster']['link'] = $color_profile[$p['poster']['id']]['link'];
		}
	}

/* Some js to control the pages */
echo '
<div id="sp_content" style="height: ',(int)$height,'px;overflow:hidden;'.$style.'" class="'.$class.'">
<script type="text/javascript">
var unread_prev = ', json_encode($prev),'
var unread_next = ', json_encode($next),'
var vertical_bar_y = ', json_encode($vertical_bar_y),'
var vertical_bar_x = ', json_encode($vertical_bar_x),'
var current_page_sp = ', json_encode($current_page),'
var total_rows_sp = ', json_encode($rows),'
var default_theme_sp = ', json_encode($settings['default_theme_url']),'
</script>';

$pages = '<script type="text/javascript">
        var pager = new UnreadPager("UnreadPosts", total_rows_sp); 
        pager.init(); 
        pager.showPageNav("pager", "UnreadPagePosition"); 		
        pager.showPage(current_page_sp);
    	</script>';	

echo '
<script type="text/javascript" src="'.$settings['default_theme_url'].'/scripts/sp-jquery-1.9.0.js"></script> 
<script type="text/javascript" src="'.$settings['default_theme_url'].'/scripts/sp-pager.js"></script>
<script type="text/javascript">
		<!--
			window.onload=regenerateUnreadPosters
		//-->
	</script>';
	
	if ($display == 'compact')
	{
		echo '
							<table id="UnreadPosts" class="sp_fullwidth">
									<tr><td class="sp_recent_info" style="visibility:hidden;height:0px;overflow:hidden;text-align:center;">&nbsp;</td></tr>';
										
		foreach ($items as $key => $item)
		{
			if (!$item['new'])
			{
				echo '
									<tr>
										<td class="sp_recent_subject">
											<div style="height:'.$row_height_compact.'px;overflow:hidden;">		
												<a href="', $item['href'], '">', $item['subject'], '</a> <span class="smalltext">', $txt['by'], ' ', $item['poster']['link'], $item['new'] ? '' : ' <a href="' . $scripturl . '?topic=' . $item['topic'] . '.msg' . $item['new_from'] . ';topicseen#new" rel="nofollow"><img src="' . $settings['lang_images_url'] . '/new.gif" alt="' . $txt['new'] . '" border="0" /></a>', '<br />[', $item['time'], ']</span><br />', empty($item['is_last']) ? '<hr />' : '';
				echo '
											</div>';			
							
				echo '							
										</td>
									</tr>';											
				$counter++;	
			}				
		}
		
		for ($i = 1; $i <= ((int)($rows - $counter % $rows)); ++$i)
		{			
			echo '<tr><td><div style="height:'.$row_height_compact.'px;overflow:hidden;">&nbsp;<br /><br /><hr style="visibility:hidden;" /></div></td></tr>';			
		}
		
		echo '
								</table>';						
	}
	elseif ($display == 'full')
	{
		echo '
								<table id="UnreadPosts" class="sp_fullwidth" cellspacing="0" cellpadding="0">
									<tr><td class="sp_recent_info" style="visibility:hidden;height:0px;overflow:hidden;text-align:center;" colspan="3">&nbsp;</td></tr>';

		foreach ($items as $key => $item)
		{
			$row_class = 'smalltext catbg';
			if ($key/2 != (int)($key/2))
				$row_class = 'smalltext windowbg';
								
			if (!$item['new'])
			{	
				echo '
									<tr>
										<td class="sp_recent_icon sp_center">
											', sp_embed_image(empty($parameters['type']) ? 'post' : 'topic'), '
										</td>
										<td class="sp_recent_subject">
											<div style="height:'.$row_height_full.'px;overflow:hidden;">
												<a href="', $item['href'], '">', $item['subject'], '</a>
												', $show_icon != 'yes' ? '' : '<a href="' . $scripturl . '?topic=' . $item['topic'] . '.msg' . $item['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt['new'] . '" border="0" /></a>', '<br />[', $item['board']['link'], ']
											</div>
										<hr style="position:relative;padding:0px;margin-left:0px;" /></td>
										<td class="sp_recent_info sp_right">
											<div style="height:'.$row_height_full.'px;overflow:hidden;">
												', $item['poster']['link'], '<br />', $item['time'], '
											</div>
										<hr /></td>
									</tr>';
				$counter++;	
			}						
		}		
				
		for ($i = 1; $i <= ((int)($rows - $counter % $rows)); ++$i)
		{			
			echo '<tr><td><div style="height:'.$row_height_full.'px;overflow:hidden;">&nbsp;</div></td></tr>';			
		}
		
		echo '
								</table>';
	}
	
	
	if ((int)$counter == 0)
	{
		echo '
								', $txt['error_sp_no_posts_found'], '</div>';
		return;
	}
	
	echo '</div>
	<div id="UnreadPagePosition" style="text-align:center;clear:both;position:relative;top:0px;">&nbsp;</div>';
	/*
	echo '
	<span id="UnreadPagination" style="height:1px;position:relative;top:0px;">&nbsp;</span>
	<script type="text/javascript">
				$(\'#UnreadPagination\').prepend(\'<div id="UnreadPagePosition" style="text-align:center;clear:both;position:relative;top:0px;">&nbsp;</div>\');
			</script>	';
	*/		
		
	if ((int)$counter > (int)$rows)
	{			
		echo '							
		<div style="text-align:center;">', $pages, '</div>'; 
	}	
}

// Unread topic list:   [board] Subject by Poster	Date
function unreadTopics($num_recent = 8, $exclude_boards = null, $include_boards = null, $output_method = 'echo')
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $user_info;
	global $modSettings, $smcFunc;

	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : (is_array($exclude_boards) ? $exclude_boards : array($exclude_boards));

	// Only some boards?.
	if (is_array($include_boards) || (int) $include_boards === $include_boards)
	{
		$include_boards = is_array($include_boards) ? $include_boards : array($include_boards);
	}
	elseif ($include_boards != null)
	{
		$output_method = $include_boards;
		$include_boards = array();
	}

	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$icon_sources = array();
	foreach ($stable_icons as $icon)
		$icon_sources[$icon] = 'images_url';

	// Find all the posts in distinct topics.  Newer ones will have higher IDs.
	$request = $smcFunc['db_query']('substring', '
		SELECT
			m.poster_time, ms.subject, m.id_topic, m.id_member, m.id_msg, b.id_board, b.name AS board_name, t.num_replies, t.num_views,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ', SUBSTRING(m.body, 1, 384) AS body, m.smileys_enabled, m.icon
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}messages AS m ON (m.id_msg = t.id_last_msg)
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			INNER JOIN {db_prefix}messages AS ms ON (ms.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = b.id_board AND lmr.id_member = {int:current_member})' : '') . '
		WHERE t.id_last_msg >= {int:min_message_id}
			' . (empty($exclude_boards) ? '' : '
			AND b.id_board NOT IN ({array_int:exclude_boards})') . '
			' . (empty($include_boards) ? '' : '
			AND b.id_board IN ({array_int:include_boards})') . '
			AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
			AND t.approved = {int:is_approved}
			AND m.approved = {int:is_approved}' : '') . '			
		ORDER BY t.id_last_msg DESC
		LIMIT ' . $num_recent,
		array(
			'current_member' => $user_info['id'],
			'include_boards' => empty($include_boards) ? '' : $include_boards,
			'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
			'min_message_id' => $modSettings['maxMsgID'] - 35 * min($num_recent, 5),
			'is_approved' => 1,			
		)
	);
	$posts = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		if ((!empty($row['is_read'])) && $row['is_read'] == 1)
			continue;
			
		$row['body'] = strip_tags(strtr(parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']), array('<br />' => '&#10;')));
		if ($smcFunc['strlen']($row['body']) > 128)
			$row['body'] = $smcFunc['substr']($row['body'], 0, 128) . '...';

		// Censor the subject.
		censorText($row['subject']);
		censorText($row['body']);

		if (empty($modSettings['messageIconChecks_disable']) && !isset($icon_sources[$row['icon']]))
			$icon_sources[$row['icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['icon'] . '.gif') ? 'images_url' : 'default_images_url';

		// Build the array.
		$posts[] = array(
			'board' => array(
				'id' => $row['id_board'],
				'name' => $row['board_name'],
				'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['board_name'] . '</a>'
			),
			'topic' => $row['id_topic'],
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
			),
			'subject' => $row['subject'],
			'replies' => $row['num_replies'],
			'views' => $row['num_views'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $row['body'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#new" rel="nofollow">' . $row['subject'] . '</a>',
			// Retained for compatibility - is technically incorrect!
			'new' => !empty($row['is_read']),
			'is_new' => empty($row['is_read']),
			'new_from' => $row['new_from'],
			'icon' => '<img src="' . $settings[$icon_sources[$row['icon']]] . '/post/' . $row['icon'] . '.gif" align="middle" alt="' . $row['icon'] . '" />',
		);
	}
	$smcFunc['db_free_result']($request);

	// Just return it.
	if ($output_method != 'echo' || empty($posts))
		return $posts;

	echo '
		<table border="0" class="ssi_table">';
	foreach ($posts as $post)
		echo '
			<tr>
				<td align="right" valign="top" nowrap="nowrap">
					[', $post['board']['link'], ']
				</td>
				<td valign="top">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $txt['by'], ' ', $post['poster']['link'], '
					', !$post['is_new'] ? '' : '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new" rel="nofollow"><img src="' . $settings['lang_images_url'] . '/new.gif" alt="' . $txt['new'] . '" /></a>', '
				</td>
				<td align="right" nowrap="nowrap">
					', $post['time'], '
				</td>
			</tr>';
	echo '
		</table>';
}

// Unread post list:   [board] Subject by Poster	Date
function unreadPosts($num_recent = 8, $exclude_boards = null, $include_boards = null, $output_method = 'echo', $limit_body = true)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $user_info;
	global $modSettings, $smcFunc;

	// Excluding certain boards...
	if ($exclude_boards === null && !empty($modSettings['recycle_enable']) && $modSettings['recycle_board'] > 0)
		$exclude_boards = array($modSettings['recycle_board']);
	else
		$exclude_boards = empty($exclude_boards) ? array() : (is_array($exclude_boards) ? $exclude_boards : array($exclude_boards));

	// What about including certain boards - note we do some protection here as pre-2.0 didn't have this parameter.
	if (is_array($include_boards) || (int) $include_boards === $include_boards)
	{
		$include_boards = is_array($include_boards) ? $include_boards : array($include_boards);
	}
	elseif ($include_boards != null)
	{
		$include_boards = array();
	}

	// Let's restrict the query boys (and girls)
	$query_where = '
		m.id_msg >= {int:min_message_id}
		' . (empty($exclude_boards) ? '' : '
		AND b.id_board NOT IN ({array_int:exclude_boards})') . '
		' . ($include_boards === null ? '' : '
		AND b.id_board IN ({array_int:include_boards})') . '
		AND {query_wanna_see_board}' . ($modSettings['postmod_active'] ? '
		AND m.approved = {int:is_approved}' : '');

	$query_where_params = array(
		'is_approved' => 1,			
		'include_boards' => $include_boards === null ? '' : $include_boards,
		'exclude_boards' => empty($exclude_boards) ? '' : $exclude_boards,
		'min_message_id' => $modSettings['maxMsgID'] - 25 * min($num_recent, 5),
	);

	// Past to this simpleton of a function...
	return unread_queryPosts($query_where, $query_where_params, $num_recent, 'm.id_msg DESC', $output_method, $limit_body);
}

// This removes code duplication in other queries - don't call it direct unless you really know what you're up to.
function unread_queryPosts($query_where = '', $query_where_params = array(), $query_limit = '', $query_order = 'm.id_msg DESC', $output_method = 'echo', $limit_body = false)
{
	global $context, $settings, $scripturl, $txt, $db_prefix, $user_info;
	global $modSettings, $smcFunc;

	// Find all the posts. Newer ones will have higher IDs.
	$request = $smcFunc['db_query']('substring', '
		SELECT
			m.poster_time, m.subject, m.id_topic, m.id_member, m.id_msg, m.id_board, b.name AS board_name,
			IFNULL(mem.real_name, m.poster_name) AS poster_name, ' . ($user_info['is_guest'] ? '1 AS is_read, 0 AS new_from' : '
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, 0)) >= m.id_msg_modified AS is_read,
			IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1 AS new_from') . ', ' . ($limit_body ? 'SUBSTRING(m.body, 1, 384) AS body' : 'm.body') . ', m.smileys_enabled
		FROM {db_prefix}messages AS m
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = m.id_board)
			LEFT JOIN {db_prefix}members AS mem ON (mem.id_member = m.id_member)' . (!$user_info['is_guest'] ? '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = m.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = m.id_board AND lmr.id_member = {int:current_member})' : '') . '
		' . (empty($query_where) ? '' : 'WHERE ' . $query_where) . '					
		ORDER BY ' . $query_order . '
		' . ($query_limit == '' ? '' : 'LIMIT ' . $query_limit),
		array_merge($query_where_params, array(
			'current_member' => $user_info['id'],
		))
	);
	$posts = array();
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{	
		if ((!empty($row['is_read'])) && $row['is_read'] == 1)
			continue;
					
		$row['body'] = parse_bbc($row['body'], $row['smileys_enabled'], $row['id_msg']);

		// Censor it!
		censorText($row['subject']);
		censorText($row['body']);

		$preview = strip_tags(strtr($row['body'], array('<br />' => '&#10;')));

		// Build the array.
		$posts[] = array(
			'id' => $row['id_msg'],
			'board' => array(
				'id' => $row['id_board'],
				'name' => $row['board_name'],
				'href' => $scripturl . '?board=' . $row['id_board'] . '.0',
				'link' => '<a href="' . $scripturl . '?board=' . $row['id_board'] . '.0">' . $row['board_name'] . '</a>'
			),
			'topic' => $row['id_topic'],
			'poster' => array(
				'id' => $row['id_member'],
				'name' => $row['poster_name'],
				'href' => empty($row['id_member']) ? '' : $scripturl . '?action=profile;u=' . $row['id_member'],
				'link' => empty($row['id_member']) ? $row['poster_name'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['id_member'] . '">' . $row['poster_name'] . '</a>'
			),
			'subject' => $row['subject'],
			'short_subject' => shorten_subject($row['subject'], 25),
			'preview' => $smcFunc['strlen']($preview) > 128 ? $smcFunc['substr']($preview, 0, 128) . '...' : $preview,
			'body' => $row['body'],
			'time' => timeformat($row['poster_time']),
			'timestamp' => forum_time(true, $row['poster_time']),
			'href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . ';topicseen#new',
			'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['id_msg'] . '#msg' . $row['id_msg'] . '" rel="nofollow">' . $row['subject'] . '</a>',
			'new' => !empty($row['is_read']),
			'is_new' => empty($row['is_read']),
			'new_from' => $row['new_from'],
		);
	}
	$smcFunc['db_free_result']($request);

	// Just return it.
	if ($output_method != 'echo' || empty($posts))
		return $posts;

	echo '
		<table border="0" class="ssi_table">';
	foreach ($posts as $post)
		echo '
			<tr>
				<td align="right" valign="top" nowrap="nowrap">
					[', $post['board']['link'], ']
				</td>
				<td valign="top">
					<a href="', $post['href'], '">', $post['subject'], '</a>
					', $txt['by'], ' ', $post['poster']['link'], '
					', $post['is_new'] ? '<a href="' . $scripturl . '?topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new" rel="nofollow"><img src="' . $settings['lang_images_url'] . '/new.gif" alt="' . $txt['new'] . '" /></a>' : '', '
				</td>
				<td align="right" nowrap="nowrap">
					', $post['time'], '
				</td>
			</tr>';
	echo '
		</table>';
}
?>