/* SP - Advanced Unread Posts  c/o Underdog @askusaquestion.net */
function UnreadPager(tableName, itemsPerPage) {
    this.tableName = tableName;
    this.itemsPerPage = itemsPerPage;
    this.currentPage = 1;
    this.pages = 0;
    this.initiated = false;
    
    this.showRecords = function(from, to) {        
        var rows = document.getElementById(tableName).rows;
        

        for (var i = 1; i < rows.length; i++) {
            if (i < from || i > to)  
                rows[i].style.display = "none";
            else
                rows[i].style.display = "";
        }
    }
    
    this.showPage = function(pageNumberUnread) {
    	if (! this.initiated) {
    		alert("not initiated");
    		return;
    	}
        var oldPageAnchor = document.getElementById("pg"+this.currentPage);
        oldPageAnchor.className = "smalltext pg-normal";
        
        this.currentPage = pageNumberUnread;
        var newPageAnchor = document.getElementById("pg"+this.currentPage);
        newPageAnchor.className = "largetext pg-selected";
        
        var from = (pageNumberUnread - 1) * itemsPerPage + 1;
        var to = from + itemsPerPage - 1;
        this.showRecords(from, to);
    }   
    
    this.prev = function() {
        if (this.currentPage > 1)
            this.showPage(this.currentPage - 1);
    }
    
    this.next = function() {
        if (this.currentPage < this.pages) {
            this.showPage(this.currentPage + 1);
        }
    }                        
    
    this.init = function() {
        var rows = document.getElementById(tableName).rows;
        var records = (rows.length - 1); 
        this.pages = Math.ceil(records / itemsPerPage);
        this.initiated = true;
    }
    this.showPageNav = function(pagerName, positionId) {
    	if (! this.initiated) {
    		alert("not initiated");
    		return;
    	}
    	var element = document.getElementById(positionId);
    	var pagerHtml = '<span onclick="' + pagerName + '.prev();" class="smalltext pg-normal"> ' + unread_prev + ' </span> ' + vertical_bar_y + ' ';
        for (var page = 1; page <= this.pages; page++) 
            pagerHtml += '<span id="pg' + page + '" class="smalltext pg-normal" onclick="' + pagerName + '.showPage(' + page + ');">' + page + '</span> ' + vertical_bar_y + ' ';
        pagerHtml += '<span onclick="'+pagerName+'.next();" class="smalltext pg-normal"> ' + unread_next + '</span>';        
        element.innerHTML = pagerHtml;
    }
}
function regenerateUnread()
{
	window.location.reload()
}

function regenerateUnreadPosters()
{
	if (document.layers)
	{
		appearUnread()
		setTimeout("window.onresize=regenerateUnread",450)
	}
}

function changeUnreadText(whichcontent)
{
	if (document.all||document.getElementById)
	{
		cross_el=document.getElementById? document.getElementById("descriptions"):document.all.descriptions
		cross_el.innerHTML='<div style="font-family:Arial Narrow Bold;font-size:small;">'+whichcontent+'</div>'
	}
	else if (document.layers)
	{
		document.d1.document.d2.document.write('<div style="font-family:Arial Narrow Bold;font-size:small;">'+whichcontent+'</div>')
		document.d1.document.d2.document.close()
	}

}

function appearUnread()
{
	document.d1.visibility="show"
}

function ReplaceContentInContainer(id,content)
{
	var container = document.getElementById(id);
	container.innerHTML = content;
}